/* \/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/ *
 *                                                                            *
 *  Yep2html.cmd                                                              *
 *                                                                            *
 *  Written by Phil Crown pcrown@airmail.net                                  *
 *                        http://web2.airmail.net/pcrown/                     *
 *                                                                            *
 *  Donated to the Public Domain 1996                                         *
 *                                                                            *
 *  Written using OS/2 Classic Rexx and OS/2 Warp v3.0 and Warp v4.0          *
 *                                                                            *
 *  Converts UrlLog (created by Yep) to <url.html>.                           *
 *  There are already scripts that do this (yepU*), but this script is        *
 *  easier to setup and maintain, imho! :-)                                   *
 *                                                                            *
 *                                                                            *
 *  * WARNING * * WARNING * * WARNING * * WARNING * * WARNING * * WARNING *   *
 *                                                                            *
 *        The UrlLog file created by Yep is deleted after processing.         *
 *                           See SysFileDelete(fin)                           *
 *                                                                            *
 *                                                                            *
 *  Quickstart:                                                               *
 *  ===========                                                               *
 *                                                                            *
 *    1.  Place yep2html.cmd in your %yarn% directory or in a directory       *
 *        in your PATH.                                                       *
 *                                                                            *
 *    2.  Edit the variables 'editor', 'fout', 'fin' and 'kill' below.        *
 *                                                                            *
 *    3.  Add yep2html.cmd to the end of the .cmd file you use to start       *
 *        yarn.exe.                                                           *
 *                                                                            *
 *          Example y.cmd to load yarn.exe and run yep2html.cmd               *
 *                                                                            *
 *              yarn.exe                                                      *
 *              call yep2html.cmd                                             *
 *                                                                            *
 *    4.  Done.                                                               *
 *                                                                            *
 *                                                                            *
 *  Avoids duplicating existing URLs in UrlLog *and* <url.html>.              *
 *  Duplicates may exist in UrlLog, but will not be imported to               *
 *  <url.html>                                                                *
 *                                                                            *
 *  First reads <url.html> (if exists) and puts all URLs in a rxqueue.        *
 *  Next, reads UrlLog and adds only new URLs to the <url.html>,              *
 *  by checking the queue to avoid duplicates.                                *
 *  Also kills specified URLs in UrlLog.                                      *
 *  Uses a system named rxqueue.                                              *
 *                                                                            *
 *                                                                            *
 *  History:                                                                  *
 *                                                                            *
 *    v1.00 12 Sep 96 - first release.                                        *
 *                                                                            *
 *    v1.01 14 Sep 96 - ReadYepCfg returned 1 instead of "" if %yarn% not     *
 *                      found.                                                *
 *                      Doesn't create rxqueue before checking if fin exists. *
 *                      Runs text editor to edit fin before importing.        *
 *                                                                            *
 *    v1.02 02 Oct 96 - Add a <br> to help space out lines to make editing    *
 *                      easier.                                               *
 *                      Only saves a link and uses the "Subject:" as the      *
 *                      description for the link in the <url>.html file.      *
 *                      Runs editor on fin and fout prior to writing          *
 *                      <url>.html to provide last minute editing             *
 *                      opportunities.                                        *
 *                                                                            *
 *    v1.03 20 Oct 96 - Newsgroup is saved along with the Subject             *
 *                                                                            *
 *  Limitations:                                                              *
 *                                                                            *
 *    fout is not checked for a valid pathname.  How is this done?            *
 *                                                                            *
 *    Edit editor, fin, fout, and kill below.                                 *
 * \/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/ */

 /* text editor                                                               */

 editor = 'q.exe'

 /* fout is the filename to save URLs to in HTML format.                      */

  fout  = "d:\so\html\yepurl.html"

 /* fin is the filename of URLs created by Yep.  (UrlLog=?? in yep.cfg).      */
 /* THIS FILE IS DELETED AFTER PROCESSING.  See SysFileDelete(fin)            */

  fin = readYepCfg();       /* get the name from %yarn%\yep.cfg               */
  if fin == "" then exit 1

 /* Any URL that contains text defined in a kill.x variable will be killed.   */
 /* kill.0 is the total number of items in the stem variable kill.            */
 /* kill.1 to kill.x are URLs that will not be saved.                         */
 /*                                                                           */
 /* For example, given the URL "http://web2.airmail.net/pcrown/"              */
 /* all these definitions will kill it;                                       */
 /*                                                                           */
 /*   kill.x = "pcrown"                                                       */
 /*   kill.x = "airmail.net"                                                  */
 /*   kill.x = "http://web2.airmail.net./pcrown/"                             */
 /*                                                                           */
 /*  I don't want to save my own URL.                                         */

  kill.0 = 1
  kill.1 = "web2.airmail.net/pcrown"

 /* \/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\ */
 /* No editing necessary beyond here                                          */

  trace o
  signal on Halt
  signal on NoValue
  "@echo off"
  parse source . . a.0                          /* source file name           */
  parse arg a.1                                 /* command line parameters    */

  say ''

  i = stream(fin, 'c', 'query exists')          /* if fin does not exist then */
  if i == '' then do                            /* return                     */
    say '['filespec('name',a.0)'] File Not found' fin
    return 0
  end

  editor fin                                    /* edit fin before importing  */

  call SysCurState 'off'
  say 'Yep2html is importing URLs'              /* display something to user  */
  qname = rxqueue('create')                     /* create a system named q    */
  qold  = rxqueue('set', qname)                 /* set q for this session     */

  drop iline.     /* Comment:, To:, Newsgroups:, Subject:, from fin           */
  i = 0
  totalgood = 0   /* total number of URLs saved                               */
  totaldupe = 0   /* "                    that are dupes                      */
  totalkill = 0   /* "                    killed.                             */
  totalgrnd = 0   /* grand total of all URLs found in fin                     */

  colordefault  = '1b'x'[0;m'       /* colors                                 */
  colorhi       = '1b'x'[1;m'
  colorlo       = '1b'x'[0;m'
  colorgood     = colorlo
  colordupe     = colorlo
  colorkill     = colorlo
  colorgrnd     = '1b'x'[1;32;m'

  foutsize = stream(fout,'c','query size')      /* write header to fout if    */
  if foutsize == "" && foutsize == 0 then       /* the file does not exist    */
    call lineout fout, "<html><head><title>Yep2Html URLs</title></head><body>"

  /* Read fout to extract URL's for comparison to avoid dupes                 */

  totalhtmlurls = 0                                 /* # of URLs in fout.     */
  call flushq                                       /* If fout exists,        */
  if foutsize \= '' then do                         /* extract urls and put   */
    do while lines(fout) \= 0                       /* them in a rxqueue to   */
      line = linein(fout)                           /* be compared with urls  */
      if pos("<a href=", line) > 0 then do          /* being imported to      */
        apos1 = pos('"', line)                      /* avoid duplication.     */
        apos2 = pos('"', line, apos1+1)             /*                        */
        line = substr(line, apos1+1, apos2-apos1-1) /*                        */
        queue line
        totalhtmlurls = totalhtmlurls + 1
/*      call charout , colorhi||totalhtmlurls||colordefault 'URLs in' fout'0d'x*/
      end
    end
/*  say colorhi||totalhtmlurls + totalgood||colordefault 'URLs in' fout*/
  end

  /* Read fin extract URL's and queue them                                    */

  do while lines(fin) \= 0
    line0 = linein(fin)         /* preserve case in line0                     */
    iline.i = line0             /* iline is everything from fin except URLs   */
    i = i + 1                   /* line0 is the URL                           */
    save = 1                    /* save this URL unless otherwise.            */
    if left(line0, 4) == "URL:" then do
      line0 = strip(line0)
      line0 = substr(line0, 6)
      line  = line0
      totalgrnd = totalgrnd + 1
      call charout , 'Found'colorgrnd totalgrnd||colordefault 'URLs.' '0d'x

      killed = 0
      do j = 1 to kill.0          /* check if the URL should not be saved     */
        kill.j = translate(kill.j)
        if pos(kill.j, line) > 0 then do
          killed = 1
          totalkill = totalkill + 1
          iterate
        end
      end

      if killed == 0 then do              /* search for dupes                 */
        qhead = ""
        do while queued() \= 0
          parse pull q
          queue q
          if qhead == q then leave        /* completed search                 */
          if qhead == "" then qhead = q
          if line == q then do            /* dupe, don't save                 */
            save = 0
            iterate
          end
        end

        subject = ""
        newsgroup = ""

        if save == 1 then do              /* save this URL                    */
          call lineout fout, '<br>'
          do j = 0 to i - 2               /* write Comment: To: Newsgroups: ..*/
            if pos("Subject: ", iline.j) > 0 then do /* save the Subject to   */
              subject = substr(iline.j, 9)           /* use in the link       */
              subject = strip(subject)
              if left(subject, 4) == "Re: " then do
                subject = substr(subject, 4)
                subject = strip(subject)
              end
            end
            else if pos("Newsgroups: ", iline.j) > 0 then do
              newsgroup = substr(iline.j, 12)
              newsgroup = strip(newsgroup)
            end
          end
          if subject \== "" then          /* write the URL                    */
            call lineout fout, '<a href="'left(line0'">',70)newsgroup subject'</a><br>'
          else
            call lineout fout, '<a href="'left(line0'">',70)newsgroup line0'</a><br>'
          totalgood = totalgood + 1
          queue line                     /* add URL to q so it won't be duped */
        end
        else do
          totaldupe = totaldupe + 1
        end
        i = 0
      end
    end
  end
  call flushq
  call rxqueue 'delete', qname            /* clear and reset q                */
  call rxqueue 'set'   , qold
  i = stream(fin , 'c', 'close')          /* close files                      */
  i = stream(fout, 'c', 'close')

  i = SysFileDelete(fin)                  /* delete UrlLog                    */

  if totalgood > 0 then colorgood = colorhi
  if totaldupe > 0 then colordupe = colorhi
  if totalkill > 0 then colorkill = colorhi

  say 'Found'colorgrnd totalgrnd||colordefault 'URLs.',
      'Imported'colorgood totalgood||colordefault'.',
      'Rejected'colordupe totaldupe colordefault'dupes.',
      'Killed'colorkill totalkill||colordefault'.'

  say colorhi||totalhtmlurls + totalgood||colordefault 'URLs in' fout

  call SysCurState 'on'

  if totalgood > 0 then editor fout            /* edit fout after importing  */
  return 0

 /*---------------------------------------------------------------------*/
 /*                              End of main                            */
 /*---------------------------------------------------------------------*/

 /*
  * Flush rxqueue
  */

  Flushq: procedure
    parse arg verbose
    if verbose \= '' then say '---- Flushing q ----'
    do while queued() \= 0
      parse pull q
      if verbose \= '' then say q
    end
    return 0

 /*
  * Ctrl- Break catcher
  */

  Halt:
    call flushq 'v'
    call rxqueue 'delete', qname
    call rxqueue 'set'   , qold
    say 'q session 'result
    say 'q current 'rxqueue('get')
    say 'ouch... line 'sigl
    call SysCurState 'on'
    exit 1


 /*
  * Initialization error handler
  */

  NoValue:
    parse source . . a.0
    say a.0 ': No value at line ' sigl
    exit 1


 /*
  * Print contents of the rxqueue
  */

  Printq: procedure
    qhead = ""
    say '---- Printing q ----'
    do while queued() \= 0
      parse pull q ; queue q
      if qhead == q then leave
      if qhead == "" then qhead = q
      say '['q']'
    end
    say '---- Printing q done. ----'
    return 0


 /*
  * ReadYepCfg
  *
  * read %yarn%\yep.cfg to get the the UrlLog filename
  *
  * Returns:
  *
  *     Success :  %yarn%\yep.cfg
  *     Error   :  ""
  *
  */

  ReadYepCfg: procedure
    yepcfg = value('yarn',,'os2environment')
    if yepcfg == '' then do
      say 'Unable to find %yarn% environment.'
      return ''
    end
    yepcfg = yepcfg||'\yep.cfg'
    i = stream(yepcfg, 'c', 'open')
    if pos("NOTREADY", i) > 0 then do
      say i yepcfg
      return ''
    end
    do while lines(yepcfg) \= 0
      line = translate(linein(yepcfg))
      if left(line, 6) == "URLLOG" then do
        c1 = pos('"', line)
        c2 = pos('"', line, c1+1)
        line = substr(line, c1+1, c2 - c1 - 1)
        i = stream(yepcfg, 'c', 'close')
        return line
      end
    end
    return ''
